DEFDBL B-E
PRINT
PRINT "To convert two-column data files"
PRINT "for one target and one projectile (one A1), relativistically "
PRINT "for UNIVERSAL plot: Lex/Lth versus E/A,"
PRINT "where Lth: Stopping Number with only relativistic corrections"
PRINT
'Note: the relativistic calculation of beta is correct down to EoverA=1E-7,
'if the projectile mass A1 is entered in u!
'(I normally use the integer A1, but this could be converted to the value
'in u using the table Masses.lst)

INPUT "Enter mass number and element symbol of projectile (e.g.,16, O): "; A1$, Proj$
A1 = VAL(A1$)

OPEN "Projs.lst" FOR INPUT AS #5
DO WHILE NOT EOF(5)                        'Find Z1
        INPUT #5, Z1, ProjList$
        IF Proj$ = ProjList$ THEN EXIT DO
        IF Z1 = 93 THEN PRINT "No projectile name found": STOP
LOOP
CLOSE

OPEN "Masses.lst" FOR INPUT AS #6    'Rest Energies of Projectiles in MeV
INPUT #6, Heading$
DO WHILE NOT EOF(6)
         INPUT #6, Z1L, A1L, E0         'To find E0
         IF Z1L <> Z1 THEN GOTO there:
         IF A1L <> A1 THEN GOTO there:  ELSE EXIT DO
         IF Z1L = 99 THEN PRINT "Projectile not found in Mass List"
there:  LOOP
CLOSE #6

                                    'To find Z2:
INPUT "Enter element symbol of target (e.g., C, N2, etc.) : "; Targ$
OPEN "Targets.lst" FOR INPUT AS #5
DO WHILE NOT EOF(5)
        INPUT #5, Z2, TargList$
        IF Targ$ = TargList$ THEN EXIT DO
        IF Z2 = 140 THEN PRINT "No target name found": STOP
LOOP
CLOSE

OPEN "atdata.txt" FOR INPUT AS #5        'Find A2
LINE INPUT #5, Heading$
LINE INPUT #5, Heading$
DO WHILE NOT EOF(5)
        INPUT #5, Z, C1, C2, A2, C3, C4  'Find rel. at. mass of natural element
        IF Z = Z2 THEN EXIT DO
LOOP
CLOSE

OPEN "Ivalues1.I49" FOR INPUT AS #5       'Find I-value I2 (in eV)
DO WHILE NOT EOF(5)
        INPUT #5, Z2i, I2
        IF Z2 = Z2i THEN EXIT DO
        IF Z2 = 100 THEN PRINT "No I-value found"
LOOP
CLOSE
mc2 = 511003    'Rest Mass of electron in eV

INPUT "Enter Names of input file and output file (*.U2):"; InFile$, OutFile$
OPEN InFile$ FOR INPUT AS #1
OPEN OutFile$ FOR OUTPUT AS #2

PRINT "     E           "; Targ$
PRINT #2, "     E           "; Targ$
DO WHILE NOT EOF(1)
        INPUT #1, EoverA, S        'E/A in MeV,S in MeV/(mg/cm2)
        E = E0 + EoverA * A1                'Double Precision!
        beta = SQR(1 - (E0 / E) ^ 2)        'relativistic
        beta2 = beta ^ 2
        Lex = S * beta ^ 2 / (.000307075# * Z1 ^ 2 * Z2 / A2)  '.307075 MeVcm2/g, see Berger
                                     'Lth with only relativistic corrections:
        Lth = LOG(2 * mc2 * beta2 / I2 / (1 - beta2)) - beta2
        PRINT USING "####.#######  "; EoverA; Lex / Lth
        PRINT #2, USING "####.#######  "; EoverA; Lex / Lth
LOOP
END

